routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [App\Http\Controllers\ArticlesController::class, 'index']);

Route::resource('articles', App\Http\Controllers\ArticlesController::class)
    ->except(['update', 'edit']);
Route::resource('users', App\Http\Controllers\UsersController::class);
Route::resource('articles.comments', \App\Http\Controllers\CommentsController::class)
    ->only(['store']);


Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Article.php
<?php

namespace App\Models;

use App\Filters\QueryFilter;
use Carbon\Carbon;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Article extends Model
{
    use HasFactory;

    protected $fillable = ['body', 'category_id', 'published_at', 'user_id'];

    protected $dates = ['published_at'];

    /**
     * @param $query
     */
    public function scopePublished($query)
    {
        $query->where('published_at', '<=', Carbon::now());
    }

    /**
     * @param $date
     */
    public function setPublishedAttribute($date)
    {
        $this->attributes['published_at'] = Carbon::parse($date);
    }

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return BelongsTo
     */
    public function category(): BelongsTo
    {
        return $this->belongsTo(Category::class);
    }

    /**
     * @return BelongsToMany
     */
    public function tags(): BelongsToMany
    {
        return $this->belongsToMany(Tag::class);
    }

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class);
    }
}

app/Http/Controllers/ArticlesController.php
<?php

namespace App\Http\Controllers;

use App\Filters\ArticleFilter;
use App\Http\Requests\ArticleRequest;
use App\Models\Article;
use App\Models\Category;
use App\Models\Tag;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class ArticlesController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth', ['except' => ['index', 'show']]);
    }


    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function index()
    {
        $articles = Article::orderBy('id', 'desc')->where('approved', true)->latest('published_at')->published()->paginate(10);

        return view('articles.index', compact('articles'));
    }


    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function create()
    {
        $tags = Tag::all();
        return view('articles.create', compact('tags'));
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(Request $request): RedirectResponse
    {
        $article = new Article($request->all());
        $article->user()->associate($request->user());
        $article->fill($request->except('tags'));
        $article->save();

        $article->tags()->sync($request->tags);
        return redirect()->action([self::class, 'index'])->with('status', "Created successfully!");
    }


    /**
     * @param Article $article
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function show(Article $article)
    {
        $tags = $article->tags;
        return view('articles.show', compact('article', 'tags'));
    }

    /**
     * @param Article $article
     * @return RedirectResponse
     */
    public function destroy(Article $article)
    {
        $article->tags()->detach();
        $article->delete();

        return redirect()->action([self::class, 'index'])->with('status', "Deleted successfully!");
    }
}

resources/views/articles/create.blade.php
@extends('layouts.app')

@section('content')

<div class="container">
    <h3 class="page-title">Create news</h3>
    <form method="post" action="{{ route('articles.store') }}">
        @csrf
        <div class="form-group mb-2">
                    <label for="body"><b>Text</b></label>
                    <input type="text" class="form-control" id="body" name="body">
                    @error('body')
                    <div class="alert alert-danger">{{$message}}</div>
                    @enderror

                    <label for="category_id"><b>Category</b></label>
                    <select class="form-control border-info  @error('category_id') is-invalid border-danger @enderror"
                            id="category_id"  name="category_id">
                        <option selected >Choose category</option>
                        @foreach(App\Models\Category::all() as $category)
                            <option value="{{$category->id}}">{{$category->name}}</option>
                        @endforeach
                    </select>

                <label for="tags" class="form-label fw-bold mt-1"><b>Tags</b></label>
                <p>
                    <a class="btn btn-primary" data-toggle="collapse" href="#tags" role="button" aria-expanded="false" aria-controls="collapseExample">
                        Tags
                    </a>
                </p>

                <div class="collapse" id="tags">
                    <div class="card card-body">
                        @foreach($tags as $tag)
                            <div class="form-check">
                                <input class="form-check-input" name="tags[]" type="checkbox"
                                value="{{$tag->id}}" id="tags{{$tag->id}}">
                                <label class="form-check-label" for="tags{{$tag->id}}">
                                    {{$tag->name}}
                                </label>
                            </div>
                        @endforeach
                    </div>
                </div>
        </div>
        <div class="my-3">
             <button type="submit" class="btn btn-primary">Create article</button>
        </div>
    </form>

</div>

@endsection

resources/views/articles/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    @auth()
        <div class="m-1">
            <a class="btn btn-outline-primary mb-2" href="{{route('articles.create')}}">Create news</a>
        </div>
    @endauth
    <h1>News:</h1>
    @if($articles->count() > 0)
        <div class="table-responsive overflow-scroll">
            <table class="table table-striped table-hover table-sm">
                <thead>
                <tr>
                    <th scope="col">News</th>
                    <th scope="col">Tags</th>
                    <th scope="col">Category</th>
{{--                    <th scope="col">Published date</th>--}}
                    <th scope="col">Created date</th>
                    <th scope="col">Author</th>
                </tr>
                </thead>
                <tbody>
                @foreach($articles as $article)
                    <tr class="align-middle">
                        <td>
                            <a href="{{route('articles.show',['article' => $article])}}">{{$article->body}}</a></td>
                        <td>
                            @if($article->tags->isNotEmpty())
                                    @foreach($article->tags as $tag)
                                        <div class="badge border border-info btn-outline-info">
                                            <p>{{$tag->name}}</p>
                                        </div>
                                    @endforeach
                            @endif
                        </td>

                        <td>{{$article->category->name}}</td>
{{--                        <td>--}}
{{--                               {{$article->published_at->format('d M Y - H:i')}}--}}
{{--                        </td>--}}
                        <td>{{$article->created_at->format('Y-m-d')}}</td>
                        <td>{{$article->user->name}}</td>
                    </tr>
                @endforeach
                </tbody>
            </table>
        </div>

        <div class="row justify-content-md-center p-5">
            <div class="col-md-auto">
                {{ $articles->links('pagination::bootstrap-4') }}
            </div>
        </div>

    @else
        <p>Нет новостей</p>
    @endif
</div>
@endsection

resources/views/articles/show.blade.php
@extends('layouts.app')

@section('content')

<div class="container">
    <div class="card mb-3">
        <div class="row g-0">
            <div class="col-md-8">
                <div class="card-body">
                    <p class="card-text">{{$article->body}}</p>
                    <p class="card-text"><b>Category:</b> {{$article->category->name}}</p>
                    @if($tags->isNotEmpty())
                        <div class="text mt-3">
                            <strong>Tags:</strong>
                        </div>
                        @foreach($tags as $tag)
                            <div class="badge border border-info text-uppercase btn-outline-info">
                                <p>{{$tag->name}}</p>
                            </div>
                        @endforeach
                    @endif
                    <p class="card-text"><b>Author:</b> {{$article->user->name}}</p>
                    <p class="card-text"><small class="text-muted"><b>Published at:</b> {{$article->published_at->format('d M Y - H:i')}}</small></p>
                    <p class="card-text"><small class="text-muted"><b>Created at:</b> {{$article->created_at->format('d M Y - H:i')}}</small></p>
                </div>
            </div>
        </div>
    </div>

    @auth()
        <div id="accordion">
            <div class="card">
                <div class="card-header" id="headingOne">
                    <button class="btn btn-link collapsed" data-toggle="collapse" data-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                        Comments
                    </button>
                </div>

                <div id="collapseOne" class="collapse" aria-labelledby="headingOne" data-parent="#accordion">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-8 scrollit">
                                <input type="hidden" id="article_id" value="{{$article->id}}">
                                @foreach($article->comments as $comment)
                                    <div id="comment-{{$comment->id}}" class="">

                                        <div class="media g-mb-30 media-comment">
                                            <div class="media-body u-shadow-v18 g-bg-secondary g-pa-30">
                                                <div class="g-mb-15">
                                                    <h5 class="h5 g-color-gray-dark-v1 mb-0">{{$comment->user->name}}</h5>
                                                    <div id="form-comment-{{$comment->id}}"></div>
                                                    <span class="g-color-gray-dark-v4 g-font-size-12">{{$comment->created_at->diffForHumans()}}</span>
                                                </div>
                                                <p id="comment-{{$comment->id}}-body">
                                                    {{$comment->content}}
                                                </p>
                                            </div>
                                        </div>
                                    </div>
                                @endforeach
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="col-4 fixed">
                <div class="comment-form">
                    <form id="create-comment">
                        @csrf
                        <input type="hidden" id="article_id" value="{{$article->id}}">
                        <div class="form-group">
                            <label for="bodyId">Comment</label>
                            <textarea id="bodyId" name="content" class="form-control" rows="3"
                                      required></textarea>
                        </div>
                        <button id="create-comment-btn" type="submit" class="btn btn-outline-primary btn-sm btn-block">Add new
                            comment
                        </button>
                    </form>
                </div>
            </div>
    @endauth

    <a href="{{route('articles.index')}}">Назад ко всем новостям</a>

</div>
@endsection